//gun.cs

datablock AudioProfile(quakerocketFireSound)
{
   filename    = "./rocket_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(quakerocketLoopSound)
{
   filename    = "./missile_cruise.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock ParticleData(quakerocketFlashParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 60;
	lifetimeVarianceMS   = 40;
	textureName          = "./blastcorona1";
	spinSpeed		= 0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;

	colors[0]     = "1 1 1 1";
	colors[1]     = "0.9 0.5 0.0 0.9";

	sizes[0]      = 21.55;
	sizes[1]      = 18.55;

	useInvAlpha = false;
};
datablock ParticleEmitterData(quakerocketFlashEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 10;
   lifeTimeMS	   = 121;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 2.0;
   thetaMin         = 00;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "quakerocketFlashParticle";
};

datablock ParticleData(quakerocketFireParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 60;
	lifetimeVarianceMS   = 40;
	textureName          = "./blastcorona1";
	spinSpeed		= 0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;

	colors[0]     = "1 1 1 1";
	colors[1]     = "0.9 0.5 0.0 0.9";

	sizes[0]      = 4.55;
	sizes[1]      = 3.55;

	useInvAlpha = false;
};
datablock ParticleEmitterData(quakerocketFireEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 10;
   lifeTimeMS	   = 121;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 00;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "quakerocketFireParticle";
};

datablock ExplosionData(quakerocketExplosion : quakeLauncherExplosion)
{
   //explosionShape = "";

   explosionShape = "add-ons/weapon_rocket_launcher/explosionSphere1.dts";

   particleEmitter = quakerocketFlashEmitter;

   emitter[0] = quakerocketFlashEmitter;
   emitter[1] = quakeLauncherExplosionEmitter2;
   emitter[2] = quakeLauncherExplosionEmitter;

   damageRadius = 5;
   radiusDamage = 80;

   impulseRadius = 6;
   impulseForce = 2500;
};
//bullet trail effects
datablock ParticleData(quakerocketTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 505;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 1.0 0.0 0.4";
	colors[1]     = "1.0 0.2 0.0 0.5";
   colors[2]     = "0.20 0.20 0.20 0.3";
   colors[3]     = "0.0 0.0 0.0 0.0";

	sizes[0]      = 0.25;
	sizes[1]      = 1.85;
   sizes[2]      = 0.35;
 	sizes[3]      = 0.05;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(quakerocketTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "quakerocketTrailParticle";
};

datablock ParticleData(quakerocketSmokeParticle)
{
	dragCoefficient      = 6;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1400;
	lifetimeVarianceMS   = 1305;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 0.2 0.0 0.2";
	colors[1]     = "1.0 1 0.9 0.1";
   colors[2]     = "0.20 0.20 0.20 0.05";
   colors[3]     = "0.0 0.0 0.0 0.0";

	sizes[0]      = 1.75;
	sizes[1]      = 0.35;
   sizes[2]      = 0.15;
 	sizes[3]      = 0;

   times[0] = 0.0;
   times[1] = 0.02;
   times[2] = 0.9;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(quakerocketSmokeEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = -15.00;
   velocityVariance = 14.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "quakerocketSmokeParticle";
};

AddDamageType("quakerocket",   '<bitmap:add-ons/Weapon_Package_QuakeType/ci_rocketl> %1',    '%2 <bitmap:add-ons/Weapon_Package_QuakeType/ci_rocketl> %1',0.2,1);
datablock ProjectileData(quakerocketProjectile : gunProjectile)
{
   projectileShapeName = "./rocket_2.dts";

   directDamage        = 40;
   directDamageType    = $DamageType::quakerocket;
   radiusDamageType    = $DamageType::quakerocket;

   impactImpulse	     = 50;
   verticalImpulse	  = 700;
   explosion           = quakerocketExplosion;
   particleEmitter     = quakerocketTrailEmitter; //bulletTrailEmitter;

   sound = quakerocketLoopSound;

   muzzleVelocity      = 80;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.9;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0;
   explodeOnPlayerImpact = true;
   explodeondeath = true;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   uiName = "";
};

//////////
// item //
//////////
datablock ItemData(quakerocketItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./quake_rocket.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Missile L.";
	iconName = "./icon_rocketl";
	doColorShift = true;
	colorShiftColor = "0.45 0.45 0.45 1.000";

	 // Dynamic properties defined by the scripts
	image = quakerocketImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(quakerocketImage)
{
   // Basic Item properties
	shapeFile = "./quake_rocket.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = quakerocketProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = quakerocketItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Boltback";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.02;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= quakerocketFireEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= quakerocketFireSound;

	stateName[3] = "Smoke";
	stateEmitter[3]					= quakerocketSmokeEmitter;
	stateEmitterTime[3]				= 0.09;
	stateEmitterNode[3]				= "tailNode";
	stateTimeoutValue[3]            = 0.38;
	stateTransitionOnTimeout[3]     = "Boltback";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

	stateName[5] = "Boltback";
	stateSequence[5]	= "Fire";
	stateScript[5]                  = "onBoltback";
	stateTimeoutValue[5]            = 0.2;
	stateTransitionOnTimeout[5]     = "Wait";

	stateName[6] = "Wait";
	stateTimeoutValue[6]            = 0.04;
	stateTransitionOnTimeout[6]     = "Ready";
};

function quakerocketImage::onFire(%this,%obj,%slot)
{
	%projectile = quakerocketProjectile;
	%spread = 0.0005;
	%shellcount = 1;

	%obj.playThread(2, shiftLeft);
	%obj.playThread(0, shiftRight);
	%obj.spawnExplosion(QuakeRecoilProjectile,"1 1 1");
            		
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
}
